package com.tinkerforge;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.smarthome.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.util.Map;
import java.util.HashMap;

@ThingActionsScope(name = "tinkerforge")
@NonNullByDefault
public class BrickDCActions implements ThingActions {

    private @Nullable DeviceHandler handler;

    @Override
    public void setThingHandler(@Nullable ThingHandler handler) { this.handler = (DeviceHandler) handler; }

    @Override
    public @Nullable ThingHandler getThingHandler() { return handler; }

        @RuleAction(label = "Set Velocity")
    public void setVelocity(
            @ActionInput(name = "velocity") short velocity) throws TinkerforgeException {
        ((BrickDC)this.handler.getDevice()).setVelocity(velocity);
    }

    public static void setVelocity(@Nullable ThingActions actions, short velocity) throws TinkerforgeException {
        if (actions instanceof BrickDCActions) {
            ((BrickDCActions) actions).setVelocity(velocity);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickDCActions class.");
        }
    }

    @RuleAction(label = "Get Velocity")
    public @ActionOutput(name = "velocity", type="short")
           Map<String, Object> getVelocity(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        short value = ((BrickDC)this.handler.getDevice()).getVelocity();
        result.put("velocity", value);
        return result;
    }

    public static Map<String, Object> getVelocity(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickDCActions) {
            return ((BrickDCActions) actions).getVelocity();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickDCActions class.");
        }
    }

    @RuleAction(label = "Get Current Velocity")
    public @ActionOutput(name = "velocity", type="short")
           Map<String, Object> getCurrentVelocity(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        short value = ((BrickDC)this.handler.getDevice()).getCurrentVelocity();
        result.put("velocity", value);
        return result;
    }

    public static Map<String, Object> getCurrentVelocity(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickDCActions) {
            return ((BrickDCActions) actions).getCurrentVelocity();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickDCActions class.");
        }
    }

    @RuleAction(label = "Set Acceleration")
    public void setAcceleration(
            @ActionInput(name = "acceleration") int acceleration) throws TinkerforgeException {
        ((BrickDC)this.handler.getDevice()).setAcceleration(acceleration);
    }

    public static void setAcceleration(@Nullable ThingActions actions, int acceleration) throws TinkerforgeException {
        if (actions instanceof BrickDCActions) {
            ((BrickDCActions) actions).setAcceleration(acceleration);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickDCActions class.");
        }
    }

    @RuleAction(label = "Get Acceleration")
    public @ActionOutput(name = "acceleration", type="int")
           Map<String, Object> getAcceleration(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickDC)this.handler.getDevice()).getAcceleration();
        result.put("acceleration", value);
        return result;
    }

    public static Map<String, Object> getAcceleration(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickDCActions) {
            return ((BrickDCActions) actions).getAcceleration();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickDCActions class.");
        }
    }

    @RuleAction(label = "Full Brake")
    public void fullBrake(
            ) throws TinkerforgeException {
        ((BrickDC)this.handler.getDevice()).fullBrake();
    }

    public static void fullBrake(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickDCActions) {
            ((BrickDCActions) actions).fullBrake();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickDCActions class.");
        }
    }

    @RuleAction(label = "Enable")
    public void enable(
            ) throws TinkerforgeException {
        ((BrickDC)this.handler.getDevice()).enable();
    }

    public static void enable(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickDCActions) {
            ((BrickDCActions) actions).enable();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickDCActions class.");
        }
    }

    @RuleAction(label = "Disable")
    public void disable(
            ) throws TinkerforgeException {
        ((BrickDC)this.handler.getDevice()).disable();
    }

    public static void disable(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickDCActions) {
            ((BrickDCActions) actions).disable();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickDCActions class.");
        }
    }

    @RuleAction(label = "Is Enabled")
    public @ActionOutput(name = "enabled", type="boolean")
           Map<String, Object> isEnabled(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        boolean value = ((BrickDC)this.handler.getDevice()).isEnabled();
        result.put("enabled", value);
        return result;
    }

    public static Map<String, Object> isEnabled(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickDCActions) {
            return ((BrickDCActions) actions).isEnabled();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickDCActions class.");
        }
    }

    @RuleAction(label = "Set PWM Frequency")
    public void setPWMFrequency(
            @ActionInput(name = "frequency") int frequency) throws TinkerforgeException {
        ((BrickDC)this.handler.getDevice()).setPWMFrequency(frequency);
    }

    public static void setPWMFrequency(@Nullable ThingActions actions, int frequency) throws TinkerforgeException {
        if (actions instanceof BrickDCActions) {
            ((BrickDCActions) actions).setPWMFrequency(frequency);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickDCActions class.");
        }
    }

    @RuleAction(label = "Get PWM Frequency")
    public @ActionOutput(name = "frequency", type="int")
           Map<String, Object> getPWMFrequency(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickDC)this.handler.getDevice()).getPWMFrequency();
        result.put("frequency", value);
        return result;
    }

    public static Map<String, Object> getPWMFrequency(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickDCActions) {
            return ((BrickDCActions) actions).getPWMFrequency();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickDCActions class.");
        }
    }

    @RuleAction(label = "Get Stack Input Voltage")
    public @ActionOutput(name = "voltage", type="int")
           Map<String, Object> getStackInputVoltage(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickDC)this.handler.getDevice()).getStackInputVoltage();
        result.put("voltage", value);
        return result;
    }

    public static Map<String, Object> getStackInputVoltage(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickDCActions) {
            return ((BrickDCActions) actions).getStackInputVoltage();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickDCActions class.");
        }
    }

    @RuleAction(label = "Get External Input Voltage")
    public @ActionOutput(name = "voltage", type="int")
           Map<String, Object> getExternalInputVoltage(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickDC)this.handler.getDevice()).getExternalInputVoltage();
        result.put("voltage", value);
        return result;
    }

    public static Map<String, Object> getExternalInputVoltage(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickDCActions) {
            return ((BrickDCActions) actions).getExternalInputVoltage();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickDCActions class.");
        }
    }

    @RuleAction(label = "Get Current Consumption")
    public @ActionOutput(name = "voltage", type="int")
           Map<String, Object> getCurrentConsumption(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickDC)this.handler.getDevice()).getCurrentConsumption();
        result.put("voltage", value);
        return result;
    }

    public static Map<String, Object> getCurrentConsumption(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickDCActions) {
            return ((BrickDCActions) actions).getCurrentConsumption();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickDCActions class.");
        }
    }

    @RuleAction(label = "Set Drive Mode")
    public void setDriveMode(
            @ActionInput(name = "mode") short mode) throws TinkerforgeException {
        ((BrickDC)this.handler.getDevice()).setDriveMode(mode);
    }

    public static void setDriveMode(@Nullable ThingActions actions, short mode) throws TinkerforgeException {
        if (actions instanceof BrickDCActions) {
            ((BrickDCActions) actions).setDriveMode(mode);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickDCActions class.");
        }
    }

    @RuleAction(label = "Get Drive Mode")
    public @ActionOutput(name = "mode", type="short")
           Map<String, Object> getDriveMode(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        short value = ((BrickDC)this.handler.getDevice()).getDriveMode();
        result.put("mode", value);
        return result;
    }

    public static Map<String, Object> getDriveMode(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickDCActions) {
            return ((BrickDCActions) actions).getDriveMode();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickDCActions class.");
        }
    }

    @RuleAction(label = "Get Minimum Voltage")
    public @ActionOutput(name = "voltage", type="int")
           Map<String, Object> getMinimumVoltage(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickDC)this.handler.getDevice()).getMinimumVoltage();
        result.put("voltage", value);
        return result;
    }

    public static Map<String, Object> getMinimumVoltage(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickDCActions) {
            return ((BrickDCActions) actions).getMinimumVoltage();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickDCActions class.");
        }
    }
}
