package com.tinkerforge;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.smarthome.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.util.Map;
import java.util.HashMap;

@ThingActionsScope(name = "tinkerforge")
@NonNullByDefault
public class BrickletCurrent12Actions implements ThingActions {

    private @Nullable DeviceHandler handler;

    @Override
    public void setThingHandler(@Nullable ThingHandler handler) { this.handler = (DeviceHandler) handler; }

    @Override
    public @Nullable ThingHandler getThingHandler() { return handler; }

        @RuleAction(label = "Get Current")
    public @ActionOutput(name = "current", type="short")
           Map<String, Object> getCurrent(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        short value = ((BrickletCurrent12)this.handler.getDevice()).getCurrent();
        result.put("current", value);
        return result;
    }

    public static Map<String, Object> getCurrent(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletCurrent12Actions) {
            return ((BrickletCurrent12Actions) actions).getCurrent();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletCurrent12Actions class.");
        }
    }

    @RuleAction(label = "Is Over Current")
    public @ActionOutput(name = "over", type="boolean")
           Map<String, Object> isOverCurrent(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        boolean value = ((BrickletCurrent12)this.handler.getDevice()).isOverCurrent();
        result.put("over", value);
        return result;
    }

    public static Map<String, Object> isOverCurrent(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletCurrent12Actions) {
            return ((BrickletCurrent12Actions) actions).isOverCurrent();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletCurrent12Actions class.");
        }
    }

    @RuleAction(label = "Get Analog Value")
    public @ActionOutput(name = "value", type="int")
           Map<String, Object> getAnalogValue(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletCurrent12)this.handler.getDevice()).getAnalogValue();
        result.put("value", value);
        return result;
    }

    public static Map<String, Object> getAnalogValue(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletCurrent12Actions) {
            return ((BrickletCurrent12Actions) actions).getAnalogValue();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletCurrent12Actions class.");
        }
    }
}
