package com.tinkerforge;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.smarthome.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.util.Map;
import java.util.HashMap;

@ThingActionsScope(name = "tinkerforge")
@NonNullByDefault
public class BrickletDistanceUSV2Actions implements ThingActions {

    private @Nullable DeviceHandler handler;

    @Override
    public void setThingHandler(@Nullable ThingHandler handler) { this.handler = (DeviceHandler) handler; }

    @Override
    public @Nullable ThingHandler getThingHandler() { return handler; }

        @RuleAction(label = "Get Distance")
    public @ActionOutput(name = "distance", type="int")
           Map<String, Object> getDistance(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletDistanceUSV2)this.handler.getDevice()).getDistance();
        result.put("distance", value);
        return result;
    }

    public static Map<String, Object> getDistance(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletDistanceUSV2Actions) {
            return ((BrickletDistanceUSV2Actions) actions).getDistance();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletDistanceUSV2Actions class.");
        }
    }

    @RuleAction(label = "Get Update Rate")
    public @ActionOutput(name = "updateRate", type="int")
           Map<String, Object> getUpdateRate(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletDistanceUSV2)this.handler.getDevice()).getUpdateRate();
        result.put("updateRate", value);
        return result;
    }

    public static Map<String, Object> getUpdateRate(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletDistanceUSV2Actions) {
            return ((BrickletDistanceUSV2Actions) actions).getUpdateRate();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletDistanceUSV2Actions class.");
        }
    }

    @RuleAction(label = "Get Distance LED Config")
    public @ActionOutput(name = "config", type="int")
           Map<String, Object> getDistanceLEDConfig(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletDistanceUSV2)this.handler.getDevice()).getDistanceLEDConfig();
        result.put("config", value);
        return result;
    }

    public static Map<String, Object> getDistanceLEDConfig(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletDistanceUSV2Actions) {
            return ((BrickletDistanceUSV2Actions) actions).getDistanceLEDConfig();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletDistanceUSV2Actions class.");
        }
    }
}
