package com.tinkerforge;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.smarthome.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.util.Map;
import java.util.HashMap;

@ThingActionsScope(name = "tinkerforge")
@NonNullByDefault
public class BrickletPiezoBuzzerActions implements ThingActions {

    private @Nullable DeviceHandler handler;

    @Override
    public void setThingHandler(@Nullable ThingHandler handler) { this.handler = (DeviceHandler) handler; }

    @Override
    public @Nullable ThingHandler getThingHandler() { return handler; }

        @RuleAction(label = "Beep")
    public void beep(
            @ActionInput(name = "duration") long duration) throws TinkerforgeException {
        ((BrickletPiezoBuzzer)this.handler.getDevice()).beep(duration);
    }

    public static void beep(@Nullable ThingActions actions, long duration) throws TinkerforgeException {
        if (actions instanceof BrickletPiezoBuzzerActions) {
            ((BrickletPiezoBuzzerActions) actions).beep(duration);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletPiezoBuzzerActions class.");
        }
    }

    @RuleAction(label = "Morse Code")
    public void morseCode(
            @ActionInput(name = "morse") String morse) throws TinkerforgeException {
        ((BrickletPiezoBuzzer)this.handler.getDevice()).morseCode(morse);
    }

    public static void morseCode(@Nullable ThingActions actions, String morse) throws TinkerforgeException {
        if (actions instanceof BrickletPiezoBuzzerActions) {
            ((BrickletPiezoBuzzerActions) actions).morseCode(morse);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletPiezoBuzzerActions class.");
        }
    }
}
