package com.tinkerforge;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.smarthome.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.util.Map;
import java.util.HashMap;

@ThingActionsScope(name = "tinkerforge")
@NonNullByDefault
public class BrickletRGBLEDMatrixActions implements ThingActions {

    private @Nullable DeviceHandler handler;

    @Override
    public void setThingHandler(@Nullable ThingHandler handler) { this.handler = (DeviceHandler) handler; }

    @Override
    public @Nullable ThingHandler getThingHandler() { return handler; }

        @RuleAction(label = "Get Red")
    public @ActionOutput(name = "red", type="int[]")
           Map<String, Object> getRed(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int[] value = ((BrickletRGBLEDMatrix)this.handler.getDevice()).getRed();
        result.put("red", value);
        return result;
    }

    public static Map<String, Object> getRed(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            return ((BrickletRGBLEDMatrixActions) actions).getRed();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Get Green")
    public @ActionOutput(name = "green", type="int[]")
           Map<String, Object> getGreen(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int[] value = ((BrickletRGBLEDMatrix)this.handler.getDevice()).getGreen();
        result.put("green", value);
        return result;
    }

    public static Map<String, Object> getGreen(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            return ((BrickletRGBLEDMatrixActions) actions).getGreen();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Get Blue")
    public @ActionOutput(name = "blue", type="int[]")
           Map<String, Object> getBlue(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int[] value = ((BrickletRGBLEDMatrix)this.handler.getDevice()).getBlue();
        result.put("blue", value);
        return result;
    }

    public static Map<String, Object> getBlue(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            return ((BrickletRGBLEDMatrixActions) actions).getBlue();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Set Red")
    public void setRed(
            @ActionInput(name = "red") int[] red) throws TinkerforgeException {
        ((BrickletRGBLEDMatrix)this.handler.getDevice()).setRed(red);
    }

    public static void setRed(@Nullable ThingActions actions, int[] red) throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            ((BrickletRGBLEDMatrixActions) actions).setRed(red);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Set Green")
    public void setGreen(
            @ActionInput(name = "green") int[] green) throws TinkerforgeException {
        ((BrickletRGBLEDMatrix)this.handler.getDevice()).setGreen(green);
    }

    public static void setGreen(@Nullable ThingActions actions, int[] green) throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            ((BrickletRGBLEDMatrixActions) actions).setGreen(green);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Set Blue")
    public void setBlue(
            @ActionInput(name = "blue") int[] blue) throws TinkerforgeException {
        ((BrickletRGBLEDMatrix)this.handler.getDevice()).setBlue(blue);
    }

    public static void setBlue(@Nullable ThingActions actions, int[] blue) throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            ((BrickletRGBLEDMatrixActions) actions).setBlue(blue);
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Get Frame Duration")
    public @ActionOutput(name = "frameDuration", type="int")
           Map<String, Object> getFrameDuration(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletRGBLEDMatrix)this.handler.getDevice()).getFrameDuration();
        result.put("frameDuration", value);
        return result;
    }

    public static Map<String, Object> getFrameDuration(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            return ((BrickletRGBLEDMatrixActions) actions).getFrameDuration();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Draw Frame")
    public void drawFrame(
            ) throws TinkerforgeException {
        ((BrickletRGBLEDMatrix)this.handler.getDevice()).drawFrame();
    }

    public static void drawFrame(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            ((BrickletRGBLEDMatrixActions) actions).drawFrame();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }

    @RuleAction(label = "Get Supply Voltage")
    public @ActionOutput(name = "voltage", type="int")
           Map<String, Object> getSupplyVoltage(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletRGBLEDMatrix)this.handler.getDevice()).getSupplyVoltage();
        result.put("voltage", value);
        return result;
    }

    public static Map<String, Object> getSupplyVoltage(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletRGBLEDMatrixActions) {
            return ((BrickletRGBLEDMatrixActions) actions).getSupplyVoltage();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletRGBLEDMatrixActions class.");
        }
    }
}
