/* ***********************************************************
 * This file was automatically generated on 2019-11-06.      *
 *                                                           *
 * OpenHAB Bindings Version 2.0.0                            *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

package com.tinkerforge;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.concurrent.CopyOnWriteArrayList;
import java.util.Arrays;
import java.util.List;
import java.net.URI;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Collections;
import java.util.function.Function;
import java.util.function.BiConsumer;
import org.eclipse.smarthome.config.core.Configuration;
import org.eclipse.smarthome.config.core.ConfigDescription;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameter.Type;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterBuilder;
import org.eclipse.smarthome.config.core.ConfigDescriptionParameterGroup;
import org.eclipse.smarthome.config.core.ParameterOption;
import org.eclipse.smarthome.core.types.State;
import org.eclipse.smarthome.core.types.StateOption;
import org.eclipse.smarthome.core.types.Command;
import org.eclipse.smarthome.core.types.CommandDescriptionBuilder;
import org.eclipse.smarthome.core.types.CommandOption;
import org.eclipse.smarthome.core.thing.ThingTypeUID;
import org.eclipse.smarthome.core.thing.type.ChannelDefinitionBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelType;
import org.eclipse.smarthome.core.thing.type.ChannelTypeBuilder;
import org.eclipse.smarthome.core.thing.type.ChannelTypeUID;
import org.eclipse.smarthome.core.thing.type.ThingType;
import org.eclipse.smarthome.core.thing.type.ThingTypeBuilder;
import org.eclipse.smarthome.core.types.StateDescriptionFragmentBuilder;
import org.eclipse.smarthome.binding.tinkerforge.internal.TinkerforgeBindingConstants;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.smarthome.core.library.types.QuantityType;
import org.eclipse.smarthome.core.library.unit.MetricPrefix;
import org.eclipse.smarthome.core.library.unit.SIUnits;
import org.eclipse.smarthome.core.library.unit.SmartHomeUnits;
import org.eclipse.smarthome.core.thing.CommonTriggerEvents;
import org.eclipse.smarthome.core.library.types.StringType;

/**
 * 360° rotary encoder with push-button
 */
public class BrickletRotaryEncoder extends Device {
	public final static int DEVICE_IDENTIFIER = 236;
	public final static String DEVICE_DISPLAY_NAME = "Rotary Encoder Bricklet";

    public final static DeviceInfo DEVICE_INFO = new DeviceInfo(DEVICE_DISPLAY_NAME, "rotaryencoder", DEVICE_IDENTIFIER, BrickletRotaryEncoder.class, BrickletRotaryEncoderActions.class);

	public final static byte FUNCTION_GET_COUNT = (byte)1;
	public final static byte FUNCTION_SET_COUNT_CALLBACK_PERIOD = (byte)2;
	public final static byte FUNCTION_GET_COUNT_CALLBACK_PERIOD = (byte)3;
	public final static byte FUNCTION_SET_COUNT_CALLBACK_THRESHOLD = (byte)4;
	public final static byte FUNCTION_GET_COUNT_CALLBACK_THRESHOLD = (byte)5;
	public final static byte FUNCTION_SET_DEBOUNCE_PERIOD = (byte)6;
	public final static byte FUNCTION_GET_DEBOUNCE_PERIOD = (byte)7;
	public final static byte FUNCTION_IS_PRESSED = (byte)10;
	public final static byte FUNCTION_GET_IDENTITY = (byte)255;
	private final static int CALLBACK_COUNT = 8;
	private final static int CALLBACK_COUNT_REACHED = 9;
	private final static int CALLBACK_PRESSED = 11;
	private final static int CALLBACK_RELEASED = 12;

	public final static char THRESHOLD_OPTION_OFF = 'x';
	public final static char THRESHOLD_OPTION_OUTSIDE = 'o';
	public final static char THRESHOLD_OPTION_INSIDE = 'i';
	public final static char THRESHOLD_OPTION_SMALLER = '<';
	public final static char THRESHOLD_OPTION_GREATER = '>';

	private List<CountListener> listenerCount = new CopyOnWriteArrayList<CountListener>();
	private List<CountReachedListener> listenerCountReached = new CopyOnWriteArrayList<CountReachedListener>();
	private List<PressedListener> listenerPressed = new CopyOnWriteArrayList<PressedListener>();
	private List<ReleasedListener> listenerReleased = new CopyOnWriteArrayList<ReleasedListener>();

	public class CountCallbackThreshold {
		public char option;
		public int min;
		public int max;

		public String toString() {
			return "[" + "option = " + option + ", " + "min = " + min + ", " + "max = " + max + "]";
		}
	}

	/**
	 * This listener is triggered periodically with the period that is set by
	 * {@link BrickletRotaryEncoder#setCountCallbackPeriod(long)}. The parameter is the count of
	 * the encoder.
	 * 
	 * The {@link BrickletRotaryEncoder.CountListener} listener is only triggered if the count has changed since the
	 * last triggering.
	 */
	public interface CountListener extends DeviceListener {
		public void count(int count);
	}

	/**
	 * This listener is triggered when the threshold as set by
	 * {@link BrickletRotaryEncoder#setCountCallbackThreshold(char, int, int)} is reached.
	 * The parameter is the count of the encoder.
	 * 
	 * If the threshold keeps being reached, the listener is triggered periodically
	 * with the period as set by {@link BrickletRotaryEncoder#setDebouncePeriod(long)}.
	 */
	public interface CountReachedListener extends DeviceListener {
		public void countReached(int count);
	}

	/**
	 * This listener is triggered when the button is pressed.
	 */
	public interface PressedListener extends DeviceListener {
		public void pressed();
	}

	/**
	 * This listener is triggered when the button is released.
	 */
	public interface ReleasedListener extends DeviceListener {
		public void released();
	}

	/**
	 * Creates an object with the unique device ID \c uid. and adds it to
	 * the IP Connection \c ipcon.
	 */
	public BrickletRotaryEncoder(String uid, IPConnection ipcon) {
		super(uid, ipcon);

		apiVersion[0] = 2;
		apiVersion[1] = 0;
		apiVersion[2] = 0;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_COUNT)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_COUNT_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_COUNT_CALLBACK_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_COUNT_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_COUNT_CALLBACK_THRESHOLD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_SET_DEBOUNCE_PERIOD)] = RESPONSE_EXPECTED_FLAG_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_DEBOUNCE_PERIOD)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_IS_PRESSED)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;
		responseExpected[IPConnection.unsignedByte(FUNCTION_GET_IDENTITY)] = RESPONSE_EXPECTED_FLAG_ALWAYS_TRUE;

		callbacks[CALLBACK_COUNT] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int count = (bb.getInt());

				for (CountListener listener: listenerCount) {
					listener.count(count);
				}
			}
		};

		callbacks[CALLBACK_COUNT_REACHED] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				ByteBuffer bb = ByteBuffer.wrap(packet, 8, packet.length - 8);
				bb.order(ByteOrder.LITTLE_ENDIAN);

				int count = (bb.getInt());

				for (CountReachedListener listener: listenerCountReached) {
					listener.countReached(count);
				}
			}
		};

		callbacks[CALLBACK_PRESSED] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				for (PressedListener listener: listenerPressed) {
					listener.pressed();
				}
			}
		};

		callbacks[CALLBACK_RELEASED] = new IPConnection.DeviceCallbackListener() {
			public void callback(byte[] packet) {
				for (ReleasedListener listener: listenerReleased) {
					listener.released();
				}
			}
		};
	}

	/**
	 * Returns the current count of the encoder. If you set reset
	 * to true, the count is set back to 0 directly after the
	 * current count is read.
	 * 
	 * The encoder has 24 steps per rotation
	 * 
	 * Turning the encoder to the left decrements the counter,
	 * so a negative count is possible.
	 */
	public int getCount(boolean reset) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)9, FUNCTION_GET_COUNT, this);

		bb.put((byte)(reset ? 1 : 0));

		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		int count = (bb.getInt());

		return count;
	}

	/**
	 * Sets the period with which the {@link BrickletRotaryEncoder.CountListener} listener is triggered
	 * periodically. A value of 0 turns the listener off.
	 * 
	 * The {@link BrickletRotaryEncoder.CountListener} listener is only triggered if the count has changed since the
	 * last triggering.
	 */
	public void setCountCallbackPeriod(long period) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_COUNT_CALLBACK_PERIOD, this);

		bb.putInt((int)period);

		sendRequest(bb.array());
	}

	/**
	 * Returns the period as set by {@link BrickletRotaryEncoder#setCountCallbackPeriod(long)}.
	 */
	public long getCountCallbackPeriod() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_COUNT_CALLBACK_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long period = IPConnection.unsignedInt(bb.getInt());

		return period;
	}

	/**
	 * Sets the thresholds for the {@link BrickletRotaryEncoder.CountReachedListener} listener.
	 * 
	 * The following options are possible:
	 * 
	 * \verbatim
	 *  "Option", "Description"
	 * 
	 *  "'x'",    "Listener is turned off"
	 *  "'o'",    "Listener is triggered when the count is *outside* the min and max values"
	 *  "'i'",    "Listener is triggered when the count is *inside* the min and max values"
	 *  "'&lt;'",    "Listener is triggered when the count is smaller than the min value (max is ignored)"
	 *  "'&gt;'",    "Listener is triggered when the count is greater than the min value (max is ignored)"
	 * \endverbatim
	 * 
	 * The default value is ('x', 0, 0).
	 */
	public void setCountCallbackThreshold(char option, int min, int max) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)17, FUNCTION_SET_COUNT_CALLBACK_THRESHOLD, this);

		bb.put((byte)option);
		bb.putInt(min);
		bb.putInt(max);

		sendRequest(bb.array());
	}

	/**
	 * Returns the threshold as set by {@link BrickletRotaryEncoder#setCountCallbackThreshold(char, int, int)}.
	 */
	public CountCallbackThreshold getCountCallbackThreshold() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_COUNT_CALLBACK_THRESHOLD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		CountCallbackThreshold obj = new CountCallbackThreshold();
		obj.option = (char)(bb.get());
		obj.min = (bb.getInt());
		obj.max = (bb.getInt());

		return obj;
	}

	/**
	 * Sets the period with which the threshold listener
	 * 
	 * * {@link BrickletRotaryEncoder.CountReachedListener}
	 * 
	 * is triggered, if the thresholds
	 * 
	 * * {@link BrickletRotaryEncoder#setCountCallbackThreshold(char, int, int)}
	 * 
	 * keeps being reached.
	 */
	public void setDebouncePeriod(long debounce) throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)12, FUNCTION_SET_DEBOUNCE_PERIOD, this);

		bb.putInt((int)debounce);

		sendRequest(bb.array());
	}

	/**
	 * Returns the debounce period as set by {@link BrickletRotaryEncoder#setDebouncePeriod(long)}.
	 */
	public long getDebouncePeriod() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_DEBOUNCE_PERIOD, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		long debounce = IPConnection.unsignedInt(bb.getInt());

		return debounce;
	}

	/**
	 * Returns *true* if the button is pressed and *false* otherwise.
	 * 
	 * It is recommended to use the {@link BrickletRotaryEncoder.PressedListener} and {@link BrickletRotaryEncoder.ReleasedListener} listeners
	 * to handle the button.
	 */
	public boolean isPressed() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_IS_PRESSED, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		boolean pressed = (bb.get()) != 0;

		return pressed;
	}

	/**
	 * Returns the UID, the UID where the Bricklet is connected to,
	 * the position, the hardware and firmware version as well as the
	 * device identifier.
	 * 
	 * The position can be 'a', 'b', 'c' or 'd'.
	 * 
	 * The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
	 * |device_identifier_constant|
	 */
	public Identity getIdentity() throws TinkerforgeException {
		ByteBuffer bb = ipcon.createRequestPacket((byte)8, FUNCTION_GET_IDENTITY, this);


		byte[] response = sendRequest(bb.array());

		bb = ByteBuffer.wrap(response, 8, response.length - 8);
		bb.order(ByteOrder.LITTLE_ENDIAN);

		Identity obj = new Identity();
		obj.uid = IPConnection.string(bb, 8);
		obj.connectedUid = IPConnection.string(bb, 8);
		obj.position = (char)(bb.get());
		for (int i = 0; i < 3; i++) {
			obj.hardwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		for (int i = 0; i < 3; i++) {
			obj.firmwareVersion[i] = IPConnection.unsignedByte(bb.get());
		}
		obj.deviceIdentifier = IPConnection.unsignedShort(bb.getShort());

		return obj;
	}

	/**
	 * Adds a Count listener.
	 */
	public void addCountListener(CountListener listener) {
		listenerCount.add(listener);
	}

	/**
	 * Removes a Count listener.
	 */
	public void removeCountListener(CountListener listener) {
		listenerCount.remove(listener);
	}

	/**
	 * Adds a CountReached listener.
	 */
	public void addCountReachedListener(CountReachedListener listener) {
		listenerCountReached.add(listener);
	}

	/**
	 * Removes a CountReached listener.
	 */
	public void removeCountReachedListener(CountReachedListener listener) {
		listenerCountReached.remove(listener);
	}

	/**
	 * Adds a Pressed listener.
	 */
	public void addPressedListener(PressedListener listener) {
		listenerPressed.add(listener);
	}

	/**
	 * Removes a Pressed listener.
	 */
	public void removePressedListener(PressedListener listener) {
		listenerPressed.remove(listener);
	}

	/**
	 * Adds a Released listener.
	 */
	public void addReleasedListener(ReleasedListener listener) {
		listenerReleased.add(listener);
	}

	/**
	 * Removes a Released listener.
	 */
	public void removeReleasedListener(ReleasedListener listener) {
		listenerReleased.remove(listener);
	}

    private final Logger logger = LoggerFactory.getLogger(BrickletRotaryEncoder.class);
    private final static Logger static_logger = LoggerFactory.getLogger(BrickletRotaryEncoder.class);

    @Override
    public void initialize(org.eclipse.smarthome.config.core.Configuration config, Function<String, org.eclipse.smarthome.config.core.Configuration> getChannelConfigFn, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletRotaryEncoderConfig cfg = (BrickletRotaryEncoderConfig) config.as(BrickletRotaryEncoderConfig.class);
        this.addCountListener((count) -> {if(true) {updateStateFn.accept("RotaryEncoderCount", transformRotaryEncoderCountCallback0(count, cfg));}});
		this.addPressedListener(() -> {if(true) {triggerChannelFn.accept("RotaryEncoderPressed", transformRotaryEncoderPressedCallback0(cfg));}});
		this.addReleasedListener(() -> {if(true) {triggerChannelFn.accept("RotaryEncoderPressed", transformRotaryEncoderPressedCallback1(cfg));}});
        
		{
		BrickletRotaryEncoderCountConfig channelCfg = getChannelConfigFn.apply("RotaryEncoderCount").as(BrickletRotaryEncoderCountConfig.class);
		this.setCountCallbackPeriod(channelCfg.updateInterval);
		this.setCountCallbackThreshold('x', 0, 0);
		}
		{
		BrickletRotaryEncoderResetCounterConfig channelCfg = getChannelConfigFn.apply("RotaryEncoderResetCounter").as(BrickletRotaryEncoderResetCounterConfig.class);
		
		}
		{
		
		}
    }

    @Override
    public void dispose(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException {
        BrickletRotaryEncoderConfig cfg = (BrickletRotaryEncoderConfig) config.as(BrickletRotaryEncoderConfig.class);
        this.listenerCount.clear();
		this.listenerPressed.clear();
		this.listenerReleased.clear();
        this.setCountCallbackPeriod(0);
		
		
		
    }

    @Override
    public List<String> getEnabledChannels(org.eclipse.smarthome.config.core.Configuration config) throws TinkerforgeException{
        BrickletRotaryEncoderConfig cfg = (BrickletRotaryEncoderConfig) config.as(BrickletRotaryEncoderConfig.class);
        List<String> result = new ArrayList<String>();
        result.add("RotaryEncoderCount");
		result.add("RotaryEncoderResetCounter");
		result.add("RotaryEncoderPressed");
        return result;
    }

    public static ChannelType getChannelType(ChannelTypeUID channelTypeUID) {
        switch(channelTypeUID.getId()) {
            case "RotaryEncoderCount":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "RotaryEncoderCount"), "Count", "Number:Dimensionless").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:RotaryEncoderCount")).withDescription("The current count of the encoder. The encoder has 24 steps per rotation. Turning the encoder to the left decrements the counter, so a negative count is possible.")
.withStateDescription(StateDescriptionFragmentBuilder.create().withPattern("%d").withReadOnly(true).build().toStateDescription()).build();
            case "RotaryEncoderResetCounter":
                return ChannelTypeBuilder.state(new ChannelTypeUID("tinkerforge", "RotaryEncoderResetCounter"), "Reset Counter", "String").withConfigDescriptionURI(URI.create("channel-type:tinkerforge:RotaryEncoderResetCounter")).withDescription("Resets the counter to 0.")
.withCommandDescription(CommandDescriptionBuilder.create().withCommandOption(new CommandOption("RESET", "Reset")).build()).build();
            default:
                static_logger.debug("Unknown channel type ID {}", channelTypeUID.getId());
                break;
        }

        return null;
    }

    public static ThingType getThingType(ThingTypeUID thingTypeUID) {
        return ThingTypeBuilder.instance(thingTypeUID, "Tinkerforge Rotary Encoder Bricklet").isListed(false).withSupportedBridgeTypeUIDs(Arrays.asList(TinkerforgeBindingConstants.THING_TYPE_BRICK_DAEMON.getId())).withConfigDescriptionURI(URI.create("thing-type:tinkerforge:" + thingTypeUID.getId())).withDescription("360° rotary encoder with push-button").withChannelDefinitions(Arrays.asList(new ChannelDefinitionBuilder("RotaryEncoderCount", new ChannelTypeUID("tinkerforge", "RotaryEncoderCount")).build(), new ChannelDefinitionBuilder("RotaryEncoderResetCounter", new ChannelTypeUID("tinkerforge", "RotaryEncoderResetCounter")).build(), new ChannelDefinitionBuilder("RotaryEncoderPressed", new ChannelTypeUID("system", "rawbutton")).withLabel("Pressed").build())).build();
    }

    public static ConfigDescription getConfigDescription(URI uri) {
        switch(uri.toASCIIString()) {
            case "thing-type:tinkerforge:rotaryencoder":
                return new ConfigDescription(uri, Arrays.asList(), Arrays.asList(new ConfigDescriptionParameterGroup("update_intervals", "null", true, "Update Intervals", "Update Intervals")));
            case "channel-type:tinkerforge:RotaryEncoderCount":
                return new ConfigDescription(uri, Arrays.asList(ConfigDescriptionParameterBuilder.create("updateInterval", Type.INTEGER).withDefault("1000").withDescription("Specifies the update interval in milliseconds. A value of 0 disables automatic updates.").withGroupName("update_intervals").withLabel("Update Interval").withUnit("ms").build()));
            case "channel-type:tinkerforge:RotaryEncoderResetCounter":
                return new ConfigDescription(uri, Arrays.asList());
            default:
                static_logger.debug("Unknown config description URI {}", uri.toASCIIString());
                break;
        }
        return null;
    }

        @Override
    public void refreshValue(String channel, org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, BiConsumer<String, org.eclipse.smarthome.core.types.State> updateStateFn, BiConsumer<String, String> triggerChannelFn) throws TinkerforgeException {
        BrickletRotaryEncoderConfig cfg = (BrickletRotaryEncoderConfig) config.as(BrickletRotaryEncoderConfig.class);
        switch(channel) {
            case "RotaryEncoderCount": {
                   BrickletRotaryEncoderCountConfig channelCfg = channelConfig.as(BrickletRotaryEncoderCountConfig.class);
                   {
            int value = this.getCount(false);
            if(true)
                updateStateFn.accept(channel, transformRotaryEncoderCountGetter0(value, cfg));
        }
                   return;
               }
            case "RotaryEncoderResetCounter":
               return;
            case "RotaryEncoderPressed":
                   {
            boolean value = this.isPressed();
            if(true)
                triggerChannelFn.accept(channel, transformRotaryEncoderPressedGetter0(value, cfg));
        }
                   return;
            default:
                logger.warn("Refresh for unknown channel {}", channel);
                break;
        }
    }
    

        @Override
    public List<SetterRefresh> handleCommand(org.eclipse.smarthome.config.core.Configuration config, org.eclipse.smarthome.config.core.Configuration channelConfig, String channel, Command command) throws TinkerforgeException {
        List<SetterRefresh> result = new ArrayList<SetterRefresh>();
        BrickletRotaryEncoderConfig cfg = (BrickletRotaryEncoderConfig) config.as(BrickletRotaryEncoderConfig.class);
        switch(channel) {
            case "RotaryEncoderResetCounter":
                if (command instanceof StringType) {
                    BrickletRotaryEncoderResetCounterConfig channelCfg = channelConfig.as(BrickletRotaryEncoderResetCounterConfig.class);
                    StringType cmd = (StringType) command;
                    this.getCount(true);
                    result.add(new SetterRefresh("RotaryEncoderCount", 0));
                } else {
                    logger.warn("Command type {} not supported for channel {}. Please use a StringType.", command.getClass().getName(), channel);
                }
                break;
            default:
                logger.warn("Command for unknown channel {}", channel);
        }
        return result;
    }

        private org.eclipse.smarthome.core.types.State transformRotaryEncoderCountCallback0(int count, BrickletRotaryEncoderConfig cfg) {
        return new QuantityType<>(count, SmartHomeUnits.ONE);
    }
	    private String transformRotaryEncoderPressedCallback0(BrickletRotaryEncoderConfig cfg) {
        return CommonTriggerEvents.PRESSED;
    }
	    private String transformRotaryEncoderPressedCallback1(BrickletRotaryEncoderConfig cfg) {
        return CommonTriggerEvents.RELEASED;
    }
	    private org.eclipse.smarthome.core.types.State transformRotaryEncoderCountGetter0(int value, BrickletRotaryEncoderConfig cfg) {
        return new QuantityType<>(value, SmartHomeUnits.ONE);
    }
	    private String transformRotaryEncoderPressedGetter0(boolean value, BrickletRotaryEncoderConfig cfg) {
        return value ? CommonTriggerEvents.PRESSED : CommonTriggerEvents.RELEASED;
    }
}
