package com.tinkerforge;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.smarthome.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.util.Map;
import java.util.HashMap;

@ThingActionsScope(name = "tinkerforge")
@NonNullByDefault
public class BrickletTiltActions implements ThingActions {

    private @Nullable DeviceHandler handler;

    @Override
    public void setThingHandler(@Nullable ThingHandler handler) { this.handler = (DeviceHandler) handler; }

    @Override
    public @Nullable ThingHandler getThingHandler() { return handler; }

        @RuleAction(label = "Get Tilt State")
    public @ActionOutput(name = "state", type="short")
           Map<String, Object> getTiltState(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        short value = ((BrickletTilt)this.handler.getDevice()).getTiltState();
        result.put("state", value);
        return result;
    }

    public static Map<String, Object> getTiltState(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletTiltActions) {
            return ((BrickletTiltActions) actions).getTiltState();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletTiltActions class.");
        }
    }
}
