package com.tinkerforge;

import org.eclipse.jdt.annotation.NonNullByDefault;
import org.eclipse.jdt.annotation.Nullable;
import org.eclipse.smarthome.binding.tinkerforge.internal.handler.DeviceHandler;
import org.eclipse.smarthome.core.thing.binding.ThingActions;
import org.eclipse.smarthome.core.thing.binding.ThingActionsScope;
import org.eclipse.smarthome.core.thing.binding.ThingHandler;
import org.openhab.core.automation.annotation.ActionInput;
import org.openhab.core.automation.annotation.ActionOutput;
import org.openhab.core.automation.annotation.RuleAction;

import java.util.Map;
import java.util.HashMap;

@ThingActionsScope(name = "tinkerforge")
@NonNullByDefault
public class BrickletUVLightV2Actions implements ThingActions {

    private @Nullable DeviceHandler handler;

    @Override
    public void setThingHandler(@Nullable ThingHandler handler) { this.handler = (DeviceHandler) handler; }

    @Override
    public @Nullable ThingHandler getThingHandler() { return handler; }

        @RuleAction(label = "Get UVA")
    public @ActionOutput(name = "uva", type="int")
           Map<String, Object> getUVA(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletUVLightV2)this.handler.getDevice()).getUVA();
        result.put("uva", value);
        return result;
    }

    public static Map<String, Object> getUVA(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletUVLightV2Actions) {
            return ((BrickletUVLightV2Actions) actions).getUVA();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletUVLightV2Actions class.");
        }
    }

    @RuleAction(label = "Get UVB")
    public @ActionOutput(name = "uvb", type="int")
           Map<String, Object> getUVB(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletUVLightV2)this.handler.getDevice()).getUVB();
        result.put("uvb", value);
        return result;
    }

    public static Map<String, Object> getUVB(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletUVLightV2Actions) {
            return ((BrickletUVLightV2Actions) actions).getUVB();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletUVLightV2Actions class.");
        }
    }

    @RuleAction(label = "Get UVI")
    public @ActionOutput(name = "uvi", type="int")
           Map<String, Object> getUVI(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletUVLightV2)this.handler.getDevice()).getUVI();
        result.put("uvi", value);
        return result;
    }

    public static Map<String, Object> getUVI(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletUVLightV2Actions) {
            return ((BrickletUVLightV2Actions) actions).getUVI();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletUVLightV2Actions class.");
        }
    }

    @RuleAction(label = "Get Configuration")
    public @ActionOutput(name = "integrationTime", type="int")
           Map<String, Object> getConfiguration(
            ) throws TinkerforgeException {
        Map<String, Object> result = new HashMap<>();
        int value = ((BrickletUVLightV2)this.handler.getDevice()).getConfiguration();
        result.put("integrationTime", value);
        return result;
    }

    public static Map<String, Object> getConfiguration(@Nullable ThingActions actions) throws TinkerforgeException {
        if (actions instanceof BrickletUVLightV2Actions) {
            return ((BrickletUVLightV2Actions) actions).getConfiguration();
        } else {
            throw new IllegalArgumentException("Instance is not an BrickletUVLightV2Actions class.");
        }
    }
}
